stages:
  - tag
  - build
  - test
  - ship
  - deploy

cache:
  key: "$CI_JOB_NAME"
  
variables:
  DOCKER_TLS_CERTDIR: ""
  DOCKER_BUILDKIT: 1
  IMAGE_TAG: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHA
  APOLLO_VERSION: latest

.branch-master: &branch-master
  if: '$CI_BUILD_REF_NAME == "master"'

.merge-request: &merge-request
  if: $CI_MERGE_REQUEST_IID

.apollo:rules:test:
  rules:
    - <<: *branch-master
      when: on_success
    - <<: *merge-request
      when: on_success

.apollo:rules:build:
  rules:
    - when: on_success

.apollo:rules:deploy:
  rules:
    - <<: *branch-master
      when: on_success

.apollo:rules:mr:
  rules:
    - <<: *merge-request
      when: on_success

workflow:
  rules:
    - if: $CI_COMMIT_REF_NAME =~ /-wip$/
      when: never
    - if: $CI_MERGE_REQUEST_IID
    - if: $CI_COMMIT_TAG
      when: never
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

test:
  stage: test
  image: "registry.gitlab.com/p3r.one/apollo:$APOLLO_VERSION"
  script:
    - apollo test
  extends:
    - .apollo:rules:test

deploy:
  stage: deploy
  image: "registry.gitlab.com/p3r.one/apollo:$APOLLO_VERSION"
  variables:
    - ANSIBLE_VERBOSITY=2
  extends:
    - .apollo:rules:deploy
  script:
    - apollo deploy
